/*
***
***
***	               	  UDP REMOTE CONTROLS
*** 
***
***                Copyright (c) 2003 Angelo Rosiello 
***                       All Rights Reserved       
***      	 	AUTHOR: Angelo Rosiello (Guilecool)
***
*** 		DATE: 30/01/2003 (maybe It was the 20th hand..)
***
***
*/





#include <stdio.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <string.h>
#include <signal.h>
#include <fcntl.h>
#include <assert.h>
#include <netdb.h>
#include <time.h>
#include <stddef.h>

#define PORT 32980		 // Listening port; you can change it if you wish :>
#define ETC "udp.conf"		 // Configuration's file

void bg();			 // background procedure
void udp_initialize();		 // address initialize procedure
char crypto(char ch);		 // crypto procedure
void logging(); 	         // logging procedure



 main() /* well, I like to put main() right here ;P */
  {
	 int sd, client_len, status, binding, fd, result, i,comando, eof;			// int declarations
         char ch[1024], temp, crypted, memorizza[100];						// char declaration
	 struct sockaddr_in server_addr, client_addr;   					// Sockaddr assignments
	 udp_initialize(&server_addr, PORT, INADDR_ANY);					// Initializing the server address
	 sd = socket(AF_INET, SOCK_DGRAM, 0);							// Socket initializing
	 if(sd < 0) perror("Socket");								// Minix style...
	 assert(sd >= 0);
	 binding = bind(sd, (struct sockaddr *) &server_addr, sizeof(server_addr));
	 if(binding != 0) perror("Bind");							// Checking eventual binding errors
	 assert(binding == 0);
	 fd = open(ETC, O_RDONLY);								// Opening the ETC file 
	 if(fd <= 0) perror("UDP.CONF");							// Checking for errors
	 assert(fd > 0);
	 
	 bg();											// The program now will get in background status

	 while(1)										// Infinite loop using while() ...
	 {
	 	for(i = 0; i< 1024; i++) ch[i] = '\0';						// Get off garbage
		for(i = 0; i< 100; i++) memorizza[i] = '\0';					// No garbage here!
         	recvfrom(sd, ch, 1023, 0, (struct sockaddr *) &client_addr, &client_len);	// Received string will be ch
		result = 1;
		i = 0;
		lseek(fd, 0, 0);								// Resetting file's offsets

		logging(ch);


		while(result)									// Getting in the .conf file
		{
	     		eof = read(fd, &temp, 1);						// Reading the file
			if(eof == 0) break;							// Break the procedure at the end of the file
			crypted = crypto(temp);
	      		if(crypted != ':' && crypted != '\n')					// I decided to use these conventions
			{
				memorizza[i] = crypted;						// Going to save the strings in "memorizza"
				i++;								// Incrementing...
			}
			else if(crypted == '\n')						// Another convention
			{
				for(i=0; i< 100; i++) memorizza[i] = '\0';			// Let's have a bath...
				i = 0;
			}
			else if(crypted == ':') 						// Getting in the cycle :>
			{
		  		if(!strcmp(memorizza, ch))					// If the string u sent matches with the file's one...
		    		{
					for(i=0; i< 100; i++) memorizza[i] = '\0';		
					i = 0;
					comando = 1;
					while(comando)						// If ch == memorizza
					{
						read(fd, &temp, 1);				// Reading from the file the PATH
						crypted = crypto(temp);						
						if(crypted != '\n')
						{
							memorizza[i] = crypted;
							i++;
						}
						else if(crypted == '\n')
						{
                                        /*
							if (fork() == 0)
							{
				 				execl(memorizza, "", NULL);	// Executing the wished program
							}
							wait(&status);				// Waiting for the son
					*/
							system(memorizza);
							comando = 0;				// Stop the while()
						}
					}
				}
				else 
				{
					for(i=0; i<100; i++) memorizza[i]= '\0';
					i = 0;
				}
	    		}
		}
	 	
	 } 											// end of while()
		    		
} 												// end of main()


/*
** Implementing the procedures
**   
** 1) Background
**   
** 2) Setting up addresses
**   
** 3) Logging
**
** 4) Decrypting the config file and reading it
** 
*/



/**********************************************
* Background procedure			      *
* Nothing to explain even...                  *
**********************************************/	 

void bg()	/* Let's put our server in background, thanks to anakata */
{
	signal(SIGHUP, SIG_IGN);
	if (fork ()!= 0)
	{
		exit(0);
	}
}




/**********************************************
* Address initialize procedure                *
**********************************************/

void udp_initialize(struct sockaddr_in *address, int port, long IPaddr) /* Let's initialize UDP, fuck u Pelagatti Lame */
{
	address->sin_family = AF_INET;
	address->sin_port = htons((u_short)port);
	address->sin_addr.s_addr = IPaddr;
}




/**********************************************
* Crypting procedure                          *
* The configuration file will be decripted    *
* The Log file will be cripted...             *
**********************************************/

char crypto(char ch)
{
        char crypted;
        int key = 0xff17261;
        crypted = ch ^ key;
        return(crypted);
}




/**********************************************
* Logging procedure                           *
* The Logs' file will be "server.log"	      *
**********************************************/

void logging(char ch[1024])
{
	struct hostent *entity;
	struct sockaddr_in client_addr;
	struct tm *ptr;
	int fd, i;
	unsigned long ip;
	char orario[30], temp[1024], crypted, carattere, indirizzo[32];
	char source[] = "Connection from \n";
	char stringa[] = " ---> Received: \n";
        time_t lt;
        lt = time(NULL);
        ptr = localtime(&lt);
        fd = open("server.log", O_CREAT | O_RDWR | O_APPEND, 0644);					  // Opening the logs' file
	if(fd < 0) perror("Opening logs' file");
	assert(fd >= 0);
        entity = gethostbyaddr((char *) &client_addr.sin_addr, sizeof(struct in_addr), AF_INET); 
        assert(entity >= 0);
        ip = inet_ntoa((struct in_addr) client_addr.sin_addr);
	i = 0;
	
	sprintf(orario, "%s", (asctime(ptr)));
	while(1)
	{
		if(orario[i] == '\n')
		{
			i = 0;
			break;
		}
		carattere = orario[i];
        	crypted = crypto(carattere);
		write(fd, &crypted, 1);
		i++;
	}
	crypted = crypto('\n');
	write(fd, &crypted, 1);

	while(1)
	{
		if(source[i] == '\n')
		{
			i = 0;
			break;
		}
	        carattere = source[i];
        	crypted = crypto(carattere);
		write(fd, &crypted, 1);
		i++;
	}
	
        sprintf(indirizzo, "%s\n", ip);
	while(1)
	{
		if(indirizzo[i] == '\n')
		{
			i = 0;
			break;
		}
		carattere = indirizzo[i];
		crypted = crypto(carattere);
		write(fd, &crypted, 1);
		i++;
	}

	while(1)
	{
		if(stringa[i] == '\n')
		{
			i = 0;
			break;
		}
		carattere = stringa[i];
		crypted = crypto(carattere);
		write(fd, &crypted, 1);
		i++;
	}	

	while(1)
	{
		if(ch[i] == '\0')
		{
			i = 0;
			break;
		}
		carattere = ch[i];
		crypted = crypto(carattere);
		write(fd, &crypted, 1);
		i++;
	}
	crypted = crypto('\n');
	write(fd, &crypted, 1);			
	write(fd, &crypted, 1);	
}

/* 
**
** 				EOF
**
**
*/
	 
